/*
   seta43
   Juan Galaz
   http://seta43.duckdns.org
   http: / / seta43.blogspot.com
   27/01/2023
   Receptor de ATH20 
   OLED + LORA

  Module SX1278 // Raspberry pico pi
    GND         ->   GND
    Vcc         ->   3.3V
    MISO        ->   16
    MOSI        ->   19
    SLCK        ->   18
    Nss         ->   17
 */

//___________OLED_________

#include "olex.h"
#include <Wire.h>


#define M_MISO  16
#define M_CS  17
#define M_SCK 18
#define M_MOSI  19

const uint8_t SPI_MISO = M_MISO;
const uint8_t SPI_CS = M_CS;
const uint8_t SPI_SCK = M_SCK;
const uint8_t SPI_MOSI = M_MOSI;

#include <SPI.h>
#include <LoRa.h>


int contador;

#define MAXLOG 50
char buffer[MAXLOG];
char bufferS[MAXLOG];
char bufferLCD[MAXLOG];
String inString = ""; // string to hold input

float h, t;
int hi, ti, nums;

void setup()
{
    pinMode(LED_BUILTIN, OUTPUT);
    Serial.begin(9600);
    // while (!Serial) {    ;   } //Comentar si no se conecta terminal (Solo
    // alimentacion)
    Serial.println("SPI DEMO");
    Wire.setSDA(0);
    Wire.setSCL(1);

    OleInit();
    xclearDisplay();

    ModeFont = 0;
    sprintf(buffer, "seta43.blogspot.com");
    xStringAT(0, 6, buffer);

    LoRa.setPins(M_CS);

    if (!LoRa.begin(433E6))
    {
        Serial.println("Starting LoRa failed!");
        while (1)
            ;
    }
    else
    {
        Serial.println("Starting LoRa OK");
    }
}


void loop()
{
  int humedad;
    int packetSize = LoRa.parsePacket();
    if (packetSize)
    {
        digitalWrite(LED_BUILTIN, HIGH);
        
        while (LoRa.available())
        {
            int inChar = LoRa.read();
            inString += (char)inChar;
        }

        inString.toCharArray(buffer, 50);
        Serial.println(buffer);
      
        ModeFont = 1;       
        if (1 == busqueda(buffer, (char*)"Humedad=", bufferS))
        {
            Serial.print(" valorHumedad=");
            Serial.println(bufferS);
            hi=atoi(bufferS);
            sprintf(bufferLCD, "H=%d%c  ", hi, 37);
            xStringAT(0, 4, bufferLCD);
        }
        if (1 == busqueda(buffer, (char*)"Temperatura=", bufferS))
        {
            Serial.print(" valorTemperatura=");
            Serial.println(bufferS);
            t=atof(bufferS);
            ti=t*10;
            sprintf(bufferLCD, "T=%d.%d%cC  ", ti/10,ti%10, 127);
            xStringAT(0, 2, bufferLCD);
        }

        ModeFont = 0;
        if (1 == busqueda(buffer, (char*)"Num=", bufferS))
        {
            Serial.print(" valorNum=");
            Serial.println(bufferS);
            nums=atoi(bufferS);
        }
        
        int mi_signal = LoRa.packetRssi();
        sprintf(bufferLCD, "S=%d  N=%d  ", mi_signal,nums);
        xStringAT(0, 0, bufferLCD);
        Serial.println(bufferLCD);
        
        inString = "";
        Serial.println("-------");

        digitalWrite(LED_BUILTIN, LOW);
    }
}



/* busca en una cadena (*in), una cadena (*busqueda), y devuelve el valor en (*valor) */
int busqueda(char* in, char* busqueda, char* valor)
{
  int z;
  char* p;

    p = strstr(in, busqueda);

    if (p != NULL)
    {
        z = strlen(busqueda);
        p += z;
        for (z = 0; z < MAXLOG; z++)
        {
            *(valor + z) = *p;
            if (*p < 33)
            {
                *(valor + z) = 0;
                break;
            }
            p++;
        }
        z = 1;
    }
    else
    {
        z = 0;
    }
    return (z);
}
