/* LORa SX1278 TRANSMITTER example.
 *  https://github.com/sandeepmistry/arduino-LoRa
 */
/* Tutorial link: http://electronoobs.com
 * Modificado por SETA43
 * seta43.duckdns.org
 *
  Module SX1278 // Arduino UNO/NANO
    GND         ->   GND
    Vcc         ->   3.3V
    MISO        ->   D12
    MOSI        ->   D11
    SLCK        ->   D13
    Nss         ->   D10
    Di00        ->   D2
    RST         ->   D9
 */
#include <SPI.h>
#include <LoRa.h> //  https://github.com/sandeepmistry/arduino-LoRa

#include <Wire.h>
#include "ATH20.h"

ATH20 ATH;


int contador;

void setup()
{
    Serial.begin(9600);

    while (!Serial)
        ;
    Serial.println("LoRa EMISOR");
    if (!LoRa.begin(433E6)) // 433E6 MHz  module
    {
        Serial.println("Starting LoRa failed!");
        while (1)
            ;
    }
    Serial.println("ATH20 DEMO");
    ATH.begin();
}


void loop()
{
  float humi, temp;

    int ret = ATH.getSensor(&humi, &temp);
    if (ret) // GET DATA OK
    {
        Serial.print("Num=");
        Serial.print(contador);
        Serial.print(" Temperatura=");
        Serial.print(temp);
        Serial.print(" Humedad=");
        Serial.print(humi * 100);
        Serial.println(" ");
    }
    else // GET DATA FAIL
    {
        Serial.println("GET DATA FROM ATH20 FAIL");
    }

    LoRa.beginPacket();
    LoRa.print("Num=");
    LoRa.print(contador);
    LoRa.print(" Temperatura=");
    LoRa.print(temp);
    LoRa.print(" Humedad=");
    LoRa.print(humi * 100);
    LoRa.print(" ");
    LoRa.endPacket();

    delay(1500);
    contador++;
}
